
# ISP Toolkit

## ISP Extractor

The ISP Extractor is a command line tool capable of extracting the value of a set of Binary ISP packet fields.

### How to run

From the installation package, run the ```isp_extractor``` script. Ensure that ```JAVA_HOME``` is defined in the environment.

The tool can be executed from any location, as follows.

```$bash
isp_extractor --help
``` 

```$bash
isp_extractor --version
``` 

```$bash
isp_extractor
  --schema mission-bandTMISP.xsd
  --isp binary_data_isp.raw
  --fields fields.txt
  --output text_data_isp.csv
  --separator "\t"
  --unavailable -42
  --verbose
```

### Fields Specification

The ISP Extractor collects the fields listed in the file provided by the ```--fields``` option and stores the values in a CSV text file.
All empty lines or lines start by the character `#` are disregarded.

## ISP Transform

The ISP Transform is a command line tool that updates a given set of fields of an existing ISP, based on a timeline specification.

### How to run

From the installation package, run the ```isp_transform``` script. Ensure that ```JAVA_HOME``` is defined in the environment.

The tool can be executed from any location, as follows.

```$bash
isp_transform --help
``` 

```$bash
isp_transform --version
``` 

```$bash
isp_transform
  --schema mission-bandTMISP.xsd
  --isp binary_data_isp.raw
  --timeline timeline.json
  --verbose
```

### Timeline Specification

The timeline is a JSON file, that specifies:

- list of time_segments, each composed of:
    - time_selection, defined by:
        - path, to the coarse time field used for selection
        - gps_time_start, formatted as YYYY-MM-DDThh:mm:ss
        - gps_time_stop, formatted as YYYY-MM-DDThh:mm:ss
    - list of updates, each composed of:
        - path, one or more fields to be updates
        - type, the type of the value to be set
        - value, the value to be set

See [metopsg_timeline.json](data/metopsg/metopsg_timeline.json) for an example.
